SystemOrganization addCategory: #PullUpToSuperclass!

Object subclass: #PullUpToSuperclass
	instanceVariableNames: 'classes commonSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PullUpToSuperclass'!

!PullUpToSuperclass commentStamp: 'HwaJong 5/3/2013 21:44' prior: 0!
m := PullUpToSuperclass new.
m commonSuperclass: Wooluspos.
m run.!

!PullUpToSuperclass methodsFor: 'accessing' stamp: 'HwaJong 5/3/2013 21:43'!
commonSuperclass: aClass
	commonSuperclass := aClass! !

!PullUpToSuperclass methodsFor: 'operations' stamp: 'HwaJong 5/3/2013 20:25'!
moveInstanceVariables

	|commonInstanceVariables|
	commonInstanceVariables := classes inject: classes anyOne instVarNames into: [:ivs :clss| ivs intersection: clss instVarNames].
	
	commonInstanceVariables do: [:iVarName| 
		(RBPullUpInstanceVariableRefactoring
			model: (RBNamespace onEnvironment: RBBrowserEnvironment new) variable: iVarName class: commonSuperclass) execute].

! !

!PullUpToSuperclass methodsFor: 'operations' stamp: 'HwaJong 5/3/2013 21:14'!
moveMethods

	|classToMethods commonSelectors|
	classToMethods := classes collect: [:each|  each -> ((each methods reject: [:m| m sendsToSuper]) reject: [:m| m sendsToSuper and: [commonSuperclass selectors include: m selector]]) ].
	
	commonSelectors := classToMethods inject: (classToMethods anyOne value collect: #selector) into: [:ivs :assoc| ivs intersection: (assoc value collect: #selector)].
	classToMethods do: [:assoc| assoc value: (assoc value select: [:me| commonSelectors includes: me selector]) ].
	
	commonSelectors := commonSelectors select: [:sel| (classToMethods collect: [:ass| ass key sourceCodeAt: sel]) asSet size = 1 ].
	
	commonSelectors do: [:yesSel| 
		|code cats cat|
		cats := (classes collect: [:cls| (cls compiledMethodAt: yesSel) category ]) copyWithoutAll: { #'as yet unclassified'}.
		cat := cats isEmpty ifTrue: [ #'as yet unclassified'] ifFalse: [cats asBag sortedCounts first value].
		code := classes anyOne sourceCodeAt: yesSel.
		commonSuperclass compile: code classified: cat.
		classes do: [:cls| cls removeSelector: yesSel]].! !

!PullUpToSuperclass methodsFor: 'operations' stamp: 'HwaJong 5/3/2013 21:42'!
run
	classes := commonSuperclass subclasses.
	self moveInstanceVariables.
	self moveMethods.! !
